diff --git a/gnu/packages/batik.scm b/gnu/packages/batik.scm
index 7f159010a5..138869dc90 100644
--- a/gnu/packages/batik.scm
+++ b/gnu/packages/batik.scm
@@ -241,7 +241,6 @@ (define-public java-xmlgraphics-commons
                #t))))))
     (native-inputs
      `(("java-apache-xml-commons-resolver" ,java-apache-xml-commons-resolver)
-       ("java-asm" ,java-asm)
        ("java-cglib" ,java-cglib)
        ("java-hamcrest" ,java-hamcrest-core)
        ("java-junit" ,java-junit)
diff --git a/gnu/packages/java.scm b/gnu/packages/java.scm
index 0fb46ce465..187a531c27 100644
--- a/gnu/packages/java.scm
+++ b/gnu/packages/java.scm
@@ -3854,7 +3854,7 @@ (define-public java-plexus-component-metadata-1.7
            java-commons-cli
            java-qdox
            java-jdom2
-           java-asm))
+           java-asm-8))
     (native-inputs
      (list java-junit java-guava java-geronimo-xbean-reflect))
     (synopsis "Inversion-of-control container for Maven")
@@ -4826,7 +4826,7 @@ (define-public java-asm-commons-8
 (define-public java-cglib
   (package
     (name "java-cglib")
-    (version "3.2.4")
+    (version "3.3.0")
     (source
      (origin
        (method git-fetch)
@@ -4838,7 +4838,7 @@ (define-public java-cglib
                                   version)))))
        (file-name (git-file-name name version))
        (sha256
-        (base32 "186451jms2zfp47yd8kxd77az2cqal1my2br7klgyp8fpl4qfg8v"))))
+        (base32 "1lnscamc6bnhh7jgij5garxagp3zn2jp4cbq0rsn4xr3l0cnd014"))))
     (build-system ant-build-system)
     (arguments
      `(;; FIXME: tests fail because junit runs
@@ -4850,8 +4850,8 @@ (define-public java-cglib
        (modify-phases %standard-phases
          (add-after 'unpack 'chdir
            (lambda _ (chdir "cglib") #t)))))
-    (inputs
-     (list java-asm java-junit))
+    (native-inputs (list java-junit))
+    (propagated-inputs (list java-asm-8))
     (home-page "https://github.com/cglib/cglib/")
     (synopsis "Java byte code generation library")
     (description "The byte code generation library CGLIB is a high level API
@@ -4939,7 +4939,7 @@ (define-public java-easymock
                (delete-file "tests2/EasyMockPropertiesTest.java"))
              #t)))))
     (inputs
-     (list java-asm java-cglib java-objenesis))
+     (list java-cglib java-objenesis))
     (native-inputs
      (list java-junit java-hamcrest-core))
     (home-page "https://easymock.org/")
@@ -5000,7 +5000,7 @@ (define-public java-jmock
                (base32
                 "12b7l22g3nrjvf2dzcw3z03fpd2chrgp0d8xkvn8w55rwb57pax6"))))
     (inputs
-     (list java-hamcrest-all java-asm java-bsh java-junit))
+     (list java-hamcrest-all java-bsh java-junit))
     (native-inputs
      `(("cglib" ,java-cglib)))
     (arguments
@@ -5018,7 +5018,6 @@ (define-public java-jmock-junit4
        #:test-dir "jmock-junit4/src/test"))
     (inputs
      `(("java-hamcrest-all" ,java-hamcrest-all)
-       ("java-asm" ,java-asm)
        ("java-bsh" ,java-bsh)
        ("java-jmock" ,java-jmock)
        ("java-jumit" ,java-junit)))))
@@ -5045,7 +5044,6 @@ (define-public java-jmock-legacy
            java-objenesis
            java-cglib
            java-jmock
-           java-asm
            java-bsh
            java-junit))
     (native-inputs
@@ -9402,8 +9400,7 @@ (define-public java-ops4j-pax-exam-core-spi
        ("junit" ,java-junit)
        ("hamcrest" ,java-hamcrest-core)
        ("cglib" ,java-cglib)
-       ("objenesis" ,java-objenesis)
-       ("asm" ,java-asm)))))
+       ("objenesis" ,java-objenesis)))))
 
 (define-public java-ops4j-pax-exam-core-junit
   (package
@@ -10049,7 +10046,6 @@ (define-public java-guice
            (install-from-pom "core/pom.xml")))))
     (propagated-inputs
      (list java-aopalliance
-           java-asm
            java-cglib
            java-guava
            java-javax-inject
@@ -10355,8 +10351,7 @@ (define-public java-fest-assert
            java-hamcrest-core
            java-mockito-1
            java-cglib
-           java-objenesis
-           java-asm))
+           java-objenesis))
     (home-page "https://github.com/alexruiz/fest-assert-2.x")
     (synopsis "FEST fluent assertions")
     (description "FEST-Assert provides a fluent interface for assertions.")
@@ -10429,7 +10424,6 @@ (define-public java-testng
        ("java-assertj" ,java-assertj)
        ("java-mockito" ,java-mockito-1)
        ("cglib" ,java-cglib)
-       ("asm" ,java-asm)
        ("aopalliance" ,java-aopalliance)))
     (home-page "https://testng.org")
     (synopsis "Testing framework")
@@ -10711,8 +10705,7 @@ (define-public java-lmax-disruptor
        ("java-hamcrest-all" ,java-hamcrest-all)))
     (native-inputs
      `(("cglib" ,java-cglib)
-       ("objenesis" ,java-objenesis)
-       ("asm" ,java-asm)))
+       ("objenesis" ,java-objenesis)))
     (home-page "https://www.lmax.com/disruptor")
     (synopsis "High performance inter-thread communication")
     (description "LMAX Disruptor is a software pattern and software component
@@ -10876,7 +10869,6 @@ (define-public java-powermock-reflect
     (native-inputs
      `(("junit" ,java-junit)
        ("cglib" ,java-cglib)
-       ("asm" ,java-asm)
        ("hamcrest" ,java-hamcrest-core)
        ("assertj" ,java-assertj)))
     (home-page "https://github.com/powermock/powermock")
@@ -10973,7 +10965,6 @@ (define-public java-powermock-modules-junit4
      `(("easymock" ,java-easymock)
        ("hamcrest" ,java-hamcrest-core)
        ("objenesis" ,java-objenesis)
-       ("asm" ,java-asm)
        ("junit" ,java-junit)))))
 
 (define-public java-powermock-api-easymock
@@ -11159,8 +11150,7 @@ (define-public java-kafka-clients
     (inputs
      (list java-slf4j-api java-lz4))
     (native-inputs
-     (list java-asm
-           java-bouncycastle
+     (list java-bouncycastle
            java-cglib
            java-easymock
            java-hamcrest-all
@@ -12032,7 +12022,6 @@ (define-public java-jline-2
            java-easymock
            java-jboss-javassist
            java-objenesis
-           java-asm
            java-hamcrest-core
            java-cglib
            java-junit
@@ -12163,7 +12152,6 @@ (define-public java-xmlunit
        ("java-mockito-1" ,java-mockito-1)
        ("java-hamcrest-all" ,java-hamcrest-all)
        ("java-objenesis" ,java-objenesis)
-       ("java-asm" ,java-asm)
        ("java-cglib" ,java-cglib)
        ("resources"
         ,(origin
@@ -12851,7 +12839,6 @@ (define-public java-eclipse-sisu-plexus
            java-guice
            java-guava
            java-aopalliance
-           java-asm
            java-cglib))
     (native-inputs
      (list java-junit))
@@ -12975,7 +12962,6 @@ (define-public java-logback-core
            java-hamcrest-core
            java-mockito-1
            java-cglib
-           java-asm
            java-objenesis
            java-joda-time))
     (home-page "https://logback.qos.ch")
diff --git a/gnu/packages/maven.scm b/gnu/packages/maven.scm
index fc3a63c263..f941bf0dd0 100644
--- a/gnu/packages/maven.scm
+++ b/gnu/packages/maven.scm
@@ -344,8 +344,7 @@ (define-public maven-resolver-transport-file
            maven-resolver-util
            maven-wagon-provider-api))
     (native-inputs
-     (list java-asm
-           java-aopalliance
+     (list java-aopalliance
            java-cglib
            java-guava
            java-guice
@@ -393,7 +392,6 @@ (define-public maven-resolver-transport-http
            java-httpcomponents-httpcore))
     (native-inputs
      (list java-aopalliance
-           java-asm
            java-cglib
            java-eclipse-aether-api
            java-eclipse-jetty-http
@@ -1262,7 +1260,6 @@ (define-public maven-model
            java-plexus-component-annotations
            java-guice
            java-cglib
-           java-asm
            java-eclipse-sisu-inject
            java-javax-inject
            java-plexus-classworlds
@@ -1473,7 +1470,6 @@ (define-public maven-repository-metadata
        ("java-plexus-component-annotations" ,java-plexus-component-annotations)
        ("java-guice" ,java-guice)
        ("java-cglib" ,java-cglib)
-       ("java-asm" ,java-asm)
        ("java-eclipse-sisu-inject" ,java-eclipse-sisu-inject)
        ("java-javax-inject" ,java-javax-inject)
        ("java-plexus-utils" ,java-plexus-utils)
@@ -2103,7 +2099,6 @@ (define-public maven-compat
        ("java-guice" ,java-guice)
        ("java-guava" ,java-guava)
        ("java-cglib" ,java-cglib)
-       ("java-asm" ,java-asm)
        ("java-modello-plugins-java" ,java-modello-plugins-java)
        ("java-modello-plugins-xml" ,java-modello-plugins-xml)
        ("java-modello-plugins-xpp3" ,java-modello-plugins-xpp3)